Attribute VB_Name = "Module1"
'PSD Image Viewer for Visual Basic 6.0
'
'Copyright 2003 by Dmitry Brant, All Rights Reserved.

'Version 1.1, Last modified 05-27-2000
'
'me@dmitrybrant.com
'
'http://www.dmitrybrant.com


'This program does not support the entire PSD specification.
'Instead, this program only supports the most common
'image types that can be created using this format.

'Feel free to make improvements or optimizations to the program.
'If you do, please tell me or show me what you have done.

'This program is FREEWARE. Use freely, but give me credit
'where credit is due. (this program is NOT in the
'public domain). If you will use this source code in
'your software, the copyright notice stated above
'must be included in your source code and/or in the
'Help/About box of your program.

'The SOURCE CODE of this program, or portions of it, may not
'be redistributed, either by itself or in a compilation
'package, without express authorization from the author.

'ALL PRODUCT NAMES MENTIONED IN THIS SOFTWARE ARE TRADEMARKS
'OR REGISTERED TRADEMARKS OF THEIR RESPECTIVE OWNERS.

'THIS SOFTWARE IS DISTRIBUTED "AS IS". THE SOFTWARE IS
'DISTRIBUTED WITH NO WARRANTY, EIHER EXPRESSED
'OR IMPLIED, INCLUDING, BY WAY OF EXAMPLE THE IMPLIED
'WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
'PURPOSE. THE AUTHOR WILL NOT BE LIABLE FOR DATA LOSS, DAMAGES,
'LOSS OF PROFITS OR ANY OTHER KIND OF LOSS RESULTING FROM THE
'USE OR MISUSE OF THIS SOFTWARE.

Option Explicit
DefInt A-Z

Private Type PsdChannelInfo
    channelId As Long
    channelLength As Long
End Type

Private Type PsdLayerInfo
    layerTop As Long
    layerLeft As Long
    layerBottom As Long
    layerRight As Long
    numChannels As Integer
    bmSig As String * 4
    bmKey As String * 4
    Opacity As Byte
    Clipping As Byte
    Flags As Byte
    Channels(0 To 9) As PsdChannelInfo  '10 channels should be enough
End Type

Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long

Public Sub DoPSD(FName As String, FObject As Object)
    Dim str1 As String, i As Integer, NumOfChannels As Integer
    Dim FWidth As Long, FHeight As Long, FLeft As Integer, FTop As Integer, Bpc As Integer
    Dim BMode As Integer, LengthOfRes As Long, Compression As Integer
    Dim x As Long, y As Long, r As Integer, g As Integer, b As Integer, a As Integer
    Dim j As Integer, k As Integer, pos1 As Long, p As Long, q As Long
    Dim LayerCount As Long, LayerResLength As Long, CompType As Integer
    Dim theHdc As Long
    
    'On Error GoTo ErrorTrap0
    
    Open FName For Binary As #1
    theHdc = FObject.hdc
    
    str1 = "    "
    
    Get #1, , str1
    If str1 <> "8BPS" Then
        Close #1
        MsgBox "This is not a valid PSD file.", vbCritical, "Error"
        Exit Sub
    End If
    
    i = GetWord
    If i <> 1 Then
        Close #1
        MsgBox "This is not a valid PSD file.", vbCritical, "Error"
        Exit Sub
    End If
    
    str1 = "      "
    Get #1, , str1
    
    NumOfChannels = GetWord
    If NumOfChannels < 1 Or NumOfChannels > 4 Then
        Close #1
        MsgBox "Unsupported number of channels:" + Str(NumOfChannels), vbCritical, "Error"
        Exit Sub
    End If
    
    FHeight = GetDword
    FWidth = GetDword
    
    Bpc = GetWord
    If Bpc <> 8 Then
        Close #1
        MsgBox "Unsupported bits per sample:" + Str(Bpc), vbCritical, "Error"
        Exit Sub
    End If
    
    BMode = GetWord
    If BMode < 1 Or BMode > 3 Then
        Close #1
        MsgBox "Unsupported color mode:" + Str(BMode), vbCritical, "Error"
        Exit Sub
    End If
    
    'end of header
    
    'palette data
    LengthOfRes = GetDword
    If LengthOfRes > 0 Then
        ReDim Palette(0 To 255) As Long
        ReDim PalR(0 To 255) As Byte
        ReDim PalG(0 To 255) As Byte
        ReDim PalB(0 To 255) As Byte
        Get #1, , PalR
        Get #1, , PalG
        Get #1, , PalB
        For i = 0 To 255
            Palette(i) = RGB(PalR(i), PalG(i), PalB(i))
        Next i
        Erase PalR
        Erase PalG
        Erase PalB
    End If
    
    'resources
    LengthOfRes = GetDword
    If LengthOfRes > 0 Then
        str1 = Space(LengthOfRes)
        Get #1, , str1
    End If
    
    'layers & misc. info
    LengthOfRes = GetDword
    If LengthOfRes > 0 Then
    
        LayerResLength = GetDword
        If LayerResLength > 0 Then
        
            LayerCount = GetWord
            If LayerCount > 32767 Then LayerCount = Abs(LayerCount - 65536)
            
            ReDim layers(0 To LayerCount - 1) As PsdLayerInfo
            
            For i = 0 To LayerCount - 1
                layers(i).layerTop = GetDword
                If layers(i).layerTop > 32000 Then layers(i).layerTop = layers(i).layerTop - 2147483648#
                layers(i).layerLeft = GetDword
                If layers(i).layerLeft > 32000 Then layers(i).layerLeft = layers(i).layerLeft - 2147483648#
                layers(i).layerBottom = GetDword
                If layers(i).layerBottom > 32000 Then layers(i).layerBottom = layers(i).layerBottom - 2147483648#
                layers(i).layerRight = GetDword
                If layers(i).layerRight > 32000 Then layers(i).layerRight = layers(i).layerRight - 2147483648#
                
                layers(i).numChannels = GetWord
                
                For j = 0 To layers(i).numChannels - 1
                    layers(i).Channels(j).channelId = GetWord
                    If layers(i).Channels(j).channelId > 32767 Then layers(i).Channels(j).channelId = layers(i).Channels(j).channelId - 65536
                    layers(i).Channels(j).channelLength = GetDword
                Next j
                
                Get #1, , layers(i).bmSig    'should be "8BIM"
                Get #1, , layers(i).bmKey    'blend mode key
                
                layers(i).Opacity = GetByte
                layers(i).Clipping = GetByte
                layers(i).Flags = GetByte
                j = GetByte

                p = GetDword        'get extra data, not used here
                str1 = Space(p)
                Get #1, , str1
            Next i
            
            'image data:
            For i = 0 To LayerCount - 1
                p = (layers(i).layerBottom - layers(i).layerTop) * (layers(i).layerRight - layers(i).layerLeft)
                'account for the null layer
                If p = 0 Then
                    For j = 0 To layers(i).numChannels - 1
                        str1 = Space(layers(i).Channels(j).channelLength)
                        Get #1, , str1
                    Next j
                Else
                    Select Case BMode
                    Case 3
                        Select Case layers(i).numChannels
                        Case 5      'RGB with 2 alpha channels
                            ReDim ScanA1(0 To p - 1) As Byte
                            ReDim ScanA2(0 To p - 1) As Byte
                            ReDim ScanR(0 To p - 1) As Byte
                            ReDim ScanG(0 To p - 1) As Byte
                            ReDim ScanB(0 To p - 1) As Byte
                            FWidth = layers(i).layerRight - layers(i).layerLeft
                            FHeight = layers(i).layerBottom - layers(i).layerTop
                            FLeft = layers(i).layerLeft
                            FTop = layers(i).layerTop
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanA1
                            Else
                                GetRleChannel ScanA1, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanR
                            Else
                                GetRleChannel ScanR, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanG
                            Else
                                GetRleChannel ScanG, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanB
                            Else
                                GetRleChannel ScanB, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanA2
                            Else
                                GetRleChannel ScanA2, FWidth, FHeight
                            End If
                            For y = 0 To FHeight - 1
                                For x = 0 To FWidth - 1
                                    r = ScanR(y * FWidth + x)
                                    g = ScanG(y * FWidth + x)
                                    b = ScanB(y * FWidth + x)
                                    a = ScanA2(y * FWidth + x)
                                    If a > layers(i).Opacity Then a = layers(i).Opacity
                                    SetPixelA theHdc, x + FLeft, y + FTop, r, g, b, a
                                Next x
                                If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                            Next y
                            Erase ScanA1
                            Erase ScanA2
                            Erase ScanR
                            Erase ScanG
                            Erase ScanB
                        Case 4          'RGB with 1 Alpha channel
                            ReDim ScanA(0 To p - 1) As Byte
                            ReDim ScanR(0 To p - 1) As Byte
                            ReDim ScanG(0 To p - 1) As Byte
                            ReDim ScanB(0 To p - 1) As Byte
                            FWidth = layers(i).layerRight - layers(i).layerLeft
                            FHeight = layers(i).layerBottom - layers(i).layerTop
                            FLeft = layers(i).layerLeft
                            FTop = layers(i).layerTop
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanA
                            Else
                                GetRleChannel ScanA, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanR
                            Else
                                GetRleChannel ScanR, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanG
                            Else
                                GetRleChannel ScanG, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanB
                            Else
                                GetRleChannel ScanB, FWidth, FHeight
                            End If
                            For y = 0 To FHeight - 1
                                For x = 0 To FWidth - 1
                                    r = ScanR(y * FWidth + x)
                                    g = ScanG(y * FWidth + x)
                                    b = ScanB(y * FWidth + x)
                                    a = ScanA(y * FWidth + x)
                                    If a > layers(i).Opacity Then a = layers(i).Opacity
                                    SetPixelA theHdc, x + FLeft, y + FTop, r, g, b, a
                                Next x
                                If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                            Next y
                            Erase ScanA
                            Erase ScanR
                            Erase ScanG
                            Erase ScanB
                        Case 3      'RGB sans alpha
                            ReDim ScanR(0 To p - 1) As Byte
                            ReDim ScanG(0 To p - 1) As Byte
                            ReDim ScanB(0 To p - 1) As Byte
                            FWidth = layers(i).layerRight - layers(i).layerLeft
                            FHeight = layers(i).layerBottom - layers(i).layerTop
                            FLeft = layers(i).layerLeft
                            FTop = layers(i).layerTop
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanR
                            Else
                                GetRleChannel ScanR, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanG
                            Else
                                GetRleChannel ScanG, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanB
                            Else
                                GetRleChannel ScanB, FWidth, FHeight
                            End If
                            a = layers(i).Opacity
                            For y = 0 To FHeight - 1
                                For x = 0 To FWidth - 1
                                    r = ScanR(y * FWidth + x)
                                    g = ScanG(y * FWidth + x)
                                    b = ScanB(y * FWidth + x)
                                    If a < 255 Then
                                        SetPixelA theHdc, x + FLeft, y + FTop, r, g, b, a
                                    Else
                                        SetPixel theHdc, x + FLeft, y + FTop, RGB(r, g, b)
                                    End If
                                Next x
                                If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                            Next y
                            Erase ScanR
                            Erase ScanG
                            Erase ScanB
                        Case Else
                            
                            'RGB with >2 alphas
                            
                        End Select
                    Case 1          'grayscale
                        Select Case layers(i).numChannels
                        Case 3      'grayscale with 2 alpha channels
                            ReDim ScanA1(0 To p - 1) As Byte
                            ReDim ScanA2(0 To p - 1) As Byte
                            ReDim ScanG(0 To p - 1) As Byte
                            FWidth = layers(i).layerRight - layers(i).layerLeft
                            FHeight = layers(i).layerBottom - layers(i).layerTop
                            FLeft = layers(i).layerLeft
                            FTop = layers(i).layerTop
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanA1
                            Else
                                GetRleChannel ScanA1, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanG
                            Else
                                GetRleChannel ScanG, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanA2
                            Else
                                GetRleChannel ScanA2, FWidth, FHeight
                            End If
                            For y = 0 To FHeight - 1
                                For x = 0 To FWidth - 1
                                    a = ScanA2(y * FWidth + x)
                                    g = ScanG(y * FWidth + x)
                                    If a > layers(i).Opacity Then a = layers(i).Opacity
                                    SetPixelA theHdc, x + FLeft, y + FTop, g, g, g, a
                                Next x
                                If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                            Next y
                            Erase ScanA1
                            Erase ScanA2
                            Erase ScanG
                        Case 2      'Grayscale with 1 alpha channel
                            ReDim ScanA(0 To p - 1) As Byte
                            ReDim ScanG(0 To p - 1) As Byte
                            FWidth = layers(i).layerRight - layers(i).layerLeft
                            FHeight = layers(i).layerBottom - layers(i).layerTop
                            FLeft = layers(i).layerLeft
                            FTop = layers(i).layerTop
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanA
                            Else
                                GetRleChannel ScanA, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanG
                            Else
                                GetRleChannel ScanG, FWidth, FHeight
                            End If
                            For y = 0 To FHeight - 1
                                For x = 0 To FWidth - 1
                                    a = ScanA(y * FWidth + x)
                                    g = ScanG(y * FWidth + x)
                                    If a > layers(i).Opacity Then a = layers(i).Opacity
                                    SetPixelA theHdc, x + FLeft, y + FTop, g, g, g, a
                                Next x
                                If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                            Next y
                            Erase ScanA
                            Erase ScanG
                        Case 1      'Grayscale only
                            ReDim ScanG(0 To p - 1) As Byte
                            FWidth = layers(i).layerRight - layers(i).layerLeft
                            FHeight = layers(i).layerBottom - layers(i).layerTop
                            FLeft = layers(i).layerLeft
                            FTop = layers(i).layerTop
        
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanG
                            Else
                                GetRleChannel ScanG, FWidth, FHeight
                            End If
                            a = layers(i).Opacity
                            For y = 0 To FHeight - 1
                                For x = 0 To FWidth - 1
                                    g = ScanG(y * FWidth + x)
                                    If a < 255 Then
                                        SetPixelA theHdc, x + FLeft, y + FTop, g, g, g, a
                                    Else
                                        SetPixel theHdc, x + FLeft, y + FTop, RGB(g, g, g)
                                    End If
                                Next x
                                If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                            Next y
                            Erase ScanG
                        Case Else
                        
                        'grayscale with >2 alphas
                        
                        End Select 'numChannels
                    Case 2
                        Select Case layers(i).numChannels
                        Case 2      'Indexed with 1 alpha
                            p = FWidth * FHeight
                            ReDim ScanA(0 To p - 1) As Byte
                            ReDim ScanG(0 To p - 1) As Byte
                    
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanG
                            Else
                                GetRleChannel ScanG, FWidth, FHeight
                            End If
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanA
                            Else
                                GetRleChannel ScanA, FWidth, FHeight
                            End If
                            q = FWidth * FHeight
                            For y = 0 To FHeight - 1
                                For x = 0 To FWidth - 1
                                    g = ScanG(y * FWidth + x)
                                    a = ScanA(y * FWidth + x)
                                    SetPixelA3 theHdc, x, y, Palette(g), a
                                Next x
                                If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                            Next y
                            Erase ScanG
                            Erase ScanA
                        Case 1      'Indexed
                            p = FWidth * FHeight
                            ReDim ScanG(0 To p - 1) As Byte
                    
                            CompType = GetWord
                            If CompType = 0 Then
                                Get #1, , ScanG
                            Else
                                GetRleChannel ScanG, FWidth, FHeight
                            End If
                            For y = 0 To FHeight - 1
                                For x = 0 To FWidth - 1
                                    g = ScanG(y * FWidth + x)
                                    SetPixel theHdc, x, y, Palette(g)
                                Next x
                                If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                            Next y
                            Erase ScanG
                        Case Else
                            
                            'Indexed with >1 alpha
                            
                        End Select
                    End Select
                
                End If 'p = 0
                
            Next i
        End If 'layerResLength
        
        'global layer mask info?
        LayerResLength = GetDword
        str1 = Space(LayerResLength)
        Get #1, , str1
        
    Else
        'nonlayered image data
        Select Case BMode
        Case 3          'RGB
            Select Case NumOfChannels
            Case 5      'RGB with 2 alpha channels
                p = (layers(i).layerBottom - layers(i).layerTop) * (layers(i).layerRight - layers(i).layerLeft)
                ReDim ScanA1(0 To p - 1) As Byte
                ReDim ScanA2(0 To p - 1) As Byte
                ReDim ScanR(0 To p - 1) As Byte
                ReDim ScanG(0 To p - 1) As Byte
                ReDim ScanB(0 To p - 1) As Byte
                FWidth = layers(i).layerRight - layers(i).layerLeft
                FHeight = layers(i).layerBottom - layers(i).layerTop
                FLeft = layers(i).layerLeft
                FTop = layers(i).layerTop
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanA1
                Else
                    GetRleChannel ScanA1, FWidth, FHeight
                End If
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanR
                Else
                    GetRleChannel ScanR, FWidth, FHeight
                End If
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanG
                Else
                    GetRleChannel ScanG, FWidth, FHeight
                End If
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanB
                Else
                    GetRleChannel ScanB, FWidth, FHeight
                End If
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanA2
                Else
                    GetRleChannel ScanA2, FWidth, FHeight
                End If
                For y = 0 To FHeight - 1
                    For x = 0 To FWidth - 1
                        r = ScanR(y * FWidth + x)
                        g = ScanG(y * FWidth + x)
                        b = ScanB(y * FWidth + x)
                        a = ScanA2(y * FWidth + x)
                        If a > layers(i).Opacity Then a = layers(i).Opacity
                        SetPixelA theHdc, x + FLeft, y + FTop, r, g, b, a
                    Next x
                    If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                Next y
                Erase ScanA1
                Erase ScanA2
                Erase ScanR
                Erase ScanG
                Erase ScanB
            Case 4      'RGB with 1 alpha
                p = (layers(i).layerBottom - layers(i).layerTop) * (layers(i).layerRight - layers(i).layerLeft)
                ReDim ScanA(0 To p - 1) As Byte
                ReDim ScanR(0 To p - 1) As Byte
                ReDim ScanG(0 To p - 1) As Byte
                ReDim ScanB(0 To p - 1) As Byte
                FWidth = layers(i).layerRight - layers(i).layerLeft
                FHeight = layers(i).layerBottom - layers(i).layerTop
                FLeft = layers(i).layerLeft
                FTop = layers(i).layerTop
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanA
                Else
                    GetRleChannel ScanA, FWidth, FHeight
                End If
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanR
                Else
                    GetRleChannel ScanR, FWidth, FHeight
                End If
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanG
                Else
                    GetRleChannel ScanG, FWidth, FHeight
                End If
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanB
                Else
                    GetRleChannel ScanB, FWidth, FHeight
                End If
                For y = 0 To FHeight - 1
                    For x = 0 To FWidth - 1
                        r = ScanR(y * FWidth + x)
                        g = ScanG(y * FWidth + x)
                        b = ScanB(y * FWidth + x)
                        a = ScanA(y * FWidth + x)
                        If a > layers(i).Opacity Then a = layers(i).Opacity
                        SetPixelA theHdc, x + FLeft, y + FTop, r, g, b, a
                    Next x
                    If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                Next y
                Erase ScanA
                Erase ScanR
                Erase ScanG
                Erase ScanB
            Case 3      'RGB sans alpha
                p = FWidth * FHeight * 3
                ReDim Scan(0 To p - 1) As Byte
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , Scan
                Else
                    GetRleChannel Scan, FWidth, FHeight * 3
                End If
                'a = layers(i).Opacity
                q = FWidth * FHeight
                For y = 0 To FHeight - 1
                    For x = 0 To FWidth - 1
                        r = Scan(y * FWidth + x)
                        g = Scan(q + y * FWidth + x)
                        b = Scan(q + q + y * FWidth + x)
                        'If a < 255 Then
                        '    SetPixelA theHdc, x, y, r, g, b, a
                        'Else
                            SetPixel theHdc, x, y, RGB(r, g, b)
                        'End If
                    Next x
                    If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                Next y
                Erase Scan
            Case Else
                
                'RGB with >2 alphas
                
            End Select
        Case 1
            Select Case NumOfChannels
            Case 3      'grayscale with 2 alpha channels
                p = (layers(i).layerBottom - layers(i).layerTop) * (layers(i).layerRight - layers(i).layerLeft)
                ReDim ScanA1(0 To p - 1) As Byte
                ReDim ScanA2(0 To p - 1) As Byte
                ReDim ScanG(0 To p - 1) As Byte
                FWidth = layers(i).layerRight - layers(i).layerLeft
                FHeight = layers(i).layerBottom - layers(i).layerTop
                FLeft = layers(i).layerLeft
                FTop = layers(i).layerTop
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanA1
                Else
                    GetRleChannel ScanA1, FWidth, FHeight
                End If
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanG
                Else
                    GetRleChannel ScanG, FWidth, FHeight
                End If
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanA2
                Else
                    GetRleChannel ScanA2, FWidth, FHeight
                End If
                For y = 0 To FHeight - 1
                    For x = 0 To FWidth - 1
                        a = ScanA2(y * FWidth + x)
                        g = ScanG(y * FWidth + x)
                        If a > layers(i).Opacity Then a = layers(i).Opacity
                        SetPixelA theHdc, x + FLeft, y + FTop, g, g, g, a
                    Next x
                    If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                Next y
                Erase ScanA1
                Erase ScanA2
                Erase ScanG
            Case 2      'Grayscale with 1 alpha channel
                p = (layers(i).layerBottom - layers(i).layerTop) * (layers(i).layerRight - layers(i).layerLeft)
                ReDim ScanA(0 To p - 1) As Byte
                ReDim ScanG(0 To p - 1) As Byte
                FWidth = layers(i).layerRight - layers(i).layerLeft
                FHeight = layers(i).layerBottom - layers(i).layerTop
                FLeft = layers(i).layerLeft
                FTop = layers(i).layerTop
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanA
                Else
                    GetRleChannel ScanA, FWidth, FHeight
                End If
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanG
                Else
                    GetRleChannel ScanG, FWidth, FHeight
                End If
                For y = 0 To FHeight - 1
                    For x = 0 To FWidth - 1
                        a = ScanA(y * FWidth + x)
                        g = ScanG(y * FWidth + x)
                        If a > layers(i).Opacity Then a = layers(i).Opacity
                        SetPixelA theHdc, x + FLeft, y + FTop, g, g, g, a
                    Next x
                    If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                Next y
                Erase ScanA
                Erase ScanG
            Case 1      'Grayscale only
                p = (layers(i).layerBottom - layers(i).layerTop) * (layers(i).layerRight - layers(i).layerLeft)
                ReDim ScanG(0 To p - 1) As Byte
                FWidth = layers(i).layerRight - layers(i).layerLeft
                FHeight = layers(i).layerBottom - layers(i).layerTop
                FLeft = layers(i).layerLeft
                FTop = layers(i).layerTop

                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanG
                Else
                    GetRleChannel ScanG, FWidth, FHeight
                End If
                a = layers(i).Opacity
                For y = 0 To FHeight - 1
                    For x = 0 To FWidth - 1
                        g = ScanG(y * FWidth + x)
                        If a < 255 Then
                            SetPixelA theHdc, x + FLeft, y + FTop, g, g, g, a
                        Else
                            SetPixel theHdc, x + FLeft, y + FTop, RGB(g, g, g)
                        End If
                    Next x
                    If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                Next y
                Erase ScanG
            Case Else
                
                'grayscale with >2 alphas
                
            End Select
        Case 2           'Indexed
            Select Case NumOfChannels
            Case 1
                p = FWidth * FHeight
                ReDim ScanG(0 To p - 1) As Byte
        
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanG
                Else
                    GetRleChannel ScanG, FWidth, FHeight
                End If
                For y = 0 To FHeight - 1
                    For x = 0 To FWidth - 1
                        g = ScanG(y * FWidth + x)
                        SetPixel theHdc, x, y, Palette(g)
                    Next x
                    If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                Next y
                Erase ScanG
            Case 2      'Indexed with Alpha
                p = FWidth * FHeight * 2
                ReDim ScanG(0 To p - 1) As Byte
        
                CompType = GetWord
                If CompType = 0 Then
                    Get #1, , ScanG
                Else
                    GetRleChannel ScanG, FWidth, FHeight * 2
                End If
                q = FWidth * FHeight
                For y = 0 To FHeight - 1
                    For x = 0 To FWidth - 1
                        g = ScanG(y * FWidth + x)
                        a = ScanG(q + y * FWidth + x)
                        SetPixelA3 theHdc, x, y, Palette(g), a
                    Next x
                    If y Mod 32 = 0 Then FObject.Refresh: DoEvents
                Next y
                Erase ScanG
            Case Else
            
                'multi-channeled indexed images?
            
            End Select
        End Select
    End If
    
DefaultExit:
    Close #1
    Erase layers
    Erase Palette
    Exit Sub

ErrorTrap0:
    Close #1
    MsgBox "There was an error reading the file:" + vbCrLf + Error$, vbCritical, "Error"
    Resume DefaultExit
End Sub

Private Function GetRleChannel(Block() As Byte, wid As Long, hgt As Long)
    Dim x As Integer, y As Integer, i As Integer, j As Integer, k As Byte
    Dim l As Integer
    For i = 0 To hgt - 1
        GetWord             'length of each RLE line
    Next i
    x = 0: y = 0
    Do
        i = GetByte
        If i > 128 Then i = i - 256
        If i = 128 Then GoTo ExtLoop
        If i < 0 Then
            'copy the next byte -i+1 times
            k = GetByte
            For l = 1 To -i + 1
                Block(y * wid + x) = k
                x = x + 1
                If x >= wid Then GoTo ExtLoop
            Next l
        ElseIf i >= 0 Then
            'copy the next i + 1 bytes literally
            For l = 1 To i + 1
                k = GetByte
                Block(y * wid + x) = k
                x = x + 1
                If x >= wid Then GoTo ExtLoop
            Next l
        End If
ExtLoop:
        If x >= wid Then x = 0: y = y + 1
        If y Mod 32 = 0 Then DoEvents
    Loop Until y >= hgt
End Function

Function GetByte() As Integer
    Dim a As Byte
    Get #1, , a
    GetByte = a
End Function

Function GetWord() As Long
    Dim a As Byte
    Dim d As Long
    Get #1, , a
    d = CLng(a) * 256
    Get #1, , a
    d = d + a
    GetWord = d
End Function

Function GetDword() As Long
    Dim a As Byte
    Dim d As Long
    Get #1, , a: If a > 127 Then a = a - 128
    d = CLng(a) * 16777216
    Get #1, , a: d = d + CLng(a) * 65536
    Get #1, , a: d = d + CLng(a) * 256
    Get #1, , a: d = d + CLng(a)
    GetDword = d
End Function

'Set an alpha-pixel
Sub SetPixelA(dc As Long, x1 As Long, y1 As Long, r1 As Integer, g1 As Integer, b1 As Integer, a1 As Integer)
    Dim col2 As Long, r As Integer, g As Integer, b As Integer, diff As Integer
    col2 = GetPixel(dc, x1, y1)
    b = (col2 \ 65536) And &HFF
    g = (col2 \ 256) And &HFF
    r = col2 And &HFF
    diff = CLng(b1 - b) * a1 / 256
    b = b + diff
    diff = CLng(g1 - g) * a1 / 256
    g = g + diff
    diff = CLng(r1 - r) * a1 / 256
    r = r + diff
    SetPixel dc, x1, y1, RGB(r, g, b)
End Sub

'Set an indexed alpha-pixel
Sub SetPixelA3(dc As Long, x1 As Long, y1 As Long, col1 As Long, a1 As Integer)
    Dim col2 As Long, r As Integer, g As Integer, b As Integer, diff As Integer
    Dim r1 As Integer, g1 As Integer, b1 As Integer
    col2 = GetPixel(dc, x1, y1)
    b = (col2 \ 65536) And &HFF
    g = (col2 \ 256) And &HFF
    r = col2 And &HFF
    b1 = (col1 \ 65536) And &HFF
    g1 = (col1 \ 256) And &HFF
    r1 = col1 And &HFF
    diff = CLng(b1 - b) * a1 / 256
    b = b + diff
    diff = CLng(g1 - g) * a1 / 256
    g = g + diff
    diff = CLng(r1 - r) * a1 / 256
    r = r + diff
    SetPixel dc, x1, y1, RGB(r, g, b)
End Sub

